GStreamer(1)

NAME
gst-launch - build and run a GStreamer pipeline

SYNOPSIS
gst-launch [OPTION...] PIPELINE-DESCRIPTION

DESCRIPTION

gst-launch is a tool that builds and runs basic GStreamer pipelines.

In simple form, a PIPELINE-DESCRIPTION is a list of elements separated by exclamation marks (!). Properties may be appended to elements, in the form property=value.

For a complete description of possible PIPELINE-DESCRIPTIONS see above under pipeline description or the GStreamer documentation.

OPTIONS
gst-launch accepts the following options:

--help
    Print help synopsis and available FLAGS

-v, --silent
    Output status information

-XTYPE, --exclude=TYPE,
    Do not output status information of TYPE

-oFILE, --output=FILE
    Save XML representation of pipeline to FILE and exit

-f, --no_fault
    Do not install a fault handler

-t, --trace
    Print memory allocation traces. The feature must be enabled at compile time to work.

-i, --iterations=N
    Stop processing after N iterations.

GSTREAMER OPTIONS
gst-launch also accepts the following options that are common to all GStreamer applications:

--gst-version
    Prints the version string of the GStreamer core library.

--gst-fatal-warnings
    Causes GStreamer to abort if a warning message occurs.

--gst-debug=STRING
    A colon seperated list of category_name=level pairs to specify debugging levels for each category. Level is in the range 0-5 where 0 will show no messages, and 5 will show all messages. The wildcard * can be used to match category names.

    Use --gst-debug-help to show category names

    Example: GST_CAT=5:GST_ELEMENT_*=3

--gst-debug-level=LEVEL
    Sets the threshold for printing debugging messages. A higher level will print more messages. The useful range is 0-5, with the default being 0.

--gst-debug-no-color
    GStreamer normally prints debugging messages so that the messages are color-coded when printed to a terminal that handles ANSI escape sequences. Using this option causes GStreamer to print messages without color.

--gst-disable-debug
    Disables debugging.

--gst-debug-help
    Prints a list of available debug categories and their default debugging level.

--gst-disable-cpu-opt
    GStreamer normally automatically detects the capabilities of the current CPU and selects the optimal implementation for some functions. Using this flag disables detection, which is useful for debugging.

--gst-plugin-spew
    GStreamer info flags to set Enable printout of errors while loading GStreamer plugins

--gst-plugin-path=PATH
    Add directories separated with ':' to the plugin search path

--gst-plugin-load=PLUGINS
    Preload plugins specified in a comma-separated list. Another way to specify plugins to preload is to use the environment variable GST_PLUGIN_PATH

--gst-scheduler=SCHEDULER
    Use SCHEDULER as the default scheduler

--gst-registry=REGISTRY
    Use the file REGISTRY as registry instead of the default

PIPELINE DESCRIPTION

A pipeline consists elements and links. Elements can be put into bins of different sorts. Elements, links and bins can be specified in a pipeline description in any order.

Elements

ELEMENTTYPE [PROPERTY1 ...]

Creates an element of type ELEMENTTYPE and sets the PROPERTIES.

Properties

PROPERTY=VALUE ...

Sets the property to the specified value. You can use gst-inspect(1) to find out about properties and allowed values of different elements.
Enumeration properties can be set by name, nick or value.

Bins

[BINTYPE.] ( [PROPERTY1 ...] PIPELINE-DESCRIPTION )
{ [PROPERTY1 ...] PIPELINE-DESCRIPTION }

Specifies that a bin of type BINTYPE is created and the given properties are set. Every element between the braces is put into the bin. Using curly braces (second line) is a short cut for using the first line and "thread" as the BINTYPE.
Please not the dot that has to be used after the BINTYPE.

Links

[[SRCELEMENT].[PAD1,...]] ! [[SINKELEMENT].[PAD1,...]] [[SRCELEMENT].[PAD1,...]] ! CAPS ! [[SINKELEMENT].[PAD1,...]]

Links the element with name SRCELEMENT to the element with name SINKELEMENT, using the caps specified in CAPS as a filter. Names can be set on elements with the name property. If the name is omitted, the element that was specified directly in front of or after the link is used. This works across bins. If a padname is given, the link is done with these pads. If no pad names are given all possibilities are tried and a matching pad is used. If multiple padnames are given, both sides must have the same number of pads specified and multiple links are done in the given order.
So the simplest link is a simple exclamation mark, that links the element to the left of it to the element right of it.
Note that when specifying either pads or element names you have to include the dot or your syntax will be misinterpreted. This is a change to the old syntax used up to version 0.6 that allowed omitting the dot when only specifying a padname.

Caps

MIMETYPE [, PROPERTY[, PROPERTY ...]]] [; CAPS[; CAPS ...]]

Creates a capability with the given mimetype and optionally with given properties. The mimetype can be escaped using " or '. If you want to chain caps, you can add more caps in the same format afterwards.

Properties

NAME[:TYPE]=VALUE
in lists and ranges: [TYPE=]VALUE

Sets the requested property in capabilites. The name is an alphanumeric value and the type can have the following case-insensitive values:
- i or int for integer values or ranges
- f or float for float values or ranges
- 4 or fourcc for FOURCC values
- b, bool or boolean for boolean values
- s, str or string for strings
- l or list for lists
If no type was given, the following order is tried: integer, float, boolean, string.
Integer values must be parsable by strtol(), floats by strtod(). FOURCC values may either be integers or strings. Boolean values are (case insensitive) yes, no, true or false and may like strings be escaped with " or '.
Ranges are in this format: [ PROPERTY, PROPERTY ]
Lists use this format: ( PROPERTY [, PROPERTY ...] )

PIPELINE CONTROL

A pipeline can be controlled by signals. SIGUSR2 will stop the pipeline (GST_STATE_NULL); SIGUSR1 will put it back to play (GST_STATE_PLAYING). By default, the pipeline will start in the playing state.
There are currently no signals defined to go into the ready or pause (GST_STATE_READY and GST_STATE_PAUSED) state explicitely.

PIPELINE EXAMPLES

The examples below assume that you have the correct plug-ins available. In general, "osssink" can be substituted with another audio output plug-in such as "esdsink", "alsasink", or "artsdsink". Likewise, "xvideosink" can be substituted with "sdlvideosink" or "aasink".

Audio playback

        gst-launch filesrc location=music.mp3 ! mad ! osssink
Play the mp3 music file "music.mp3" using a libmad-based plug-in and output to an OSS device

        gst-launch filesrc location=music.ogg ! oggdemux ! vorbisdec ! audioconvert ! osssink
Play an Ogg Vorbis format file

        gst-launch gnomevfssrc location=music.mp3 ! mad ! osssink
        gst-launch gnomevfssrc location=http://domain.com/music.mp3 ! mad ! osssink
Play an mp3 file or an http stream using GNOME-VFS

        gst-launch gnomevfssrc location=smb://computer/music.mp3 ! mad ! osssink
Use GNOME-VFS to play an mp3 file located on an SMB server

Format conversion

        gst-launch filesrc location=music.mp3 ! mad ! vorbisenc ! filesink location=music.ogg
Convert an mp3 music file to an Ogg Vorbis file

        gst-launch filesrc location=music.mp3 ! mad ! flacenc ! filesink location=test.flac
Convert to the FLAC format

Other

        gst-launch filesrc location=music.wav ! wavparse ! osssink
Plays a .WAV file

        gst-launch filesrc location=music.wav ! wavparse ! vorbisenc ! filesink location=music.ogg
        gst-launch filesrc location=music.wav ! wavparse ! mpegaudio ! filesink location=music.mp3
Convert a .WAV file into Ogg Vorbis (or mp3) file

Alternatively, if you have lame installed (and have the lame plug-in), you can substitute lame for mpegaudio in the previous example. It gives better results than mpegaudio.

        gst-launch cdparanoia ! mpegaudio ! filesink location=cd.mp3
Rip all tracks from compact disc and convert them into a single mp3 file

Using gst-inspect(1), it is possible to discover settings for cdparanoia that will tell it to rip individual tracks.

        gst-launch osssrc ! vorbisenc ! filesink location=input.ogg
Record sound from your audio input and encode it into an ogg file

Video

        gst-launch filesrc location=JB_FF9_TheGravityOfLove.mpg ! mpegdemux ! mpeg2dec ! xvideosink
Display only the video portion of an MPEG-1 video file, outputting to an X display window

        gst-launch filesrc location=/flflfj.vob ! mpegdemux ! mpeg2dec ! sdlvideosink
Display the video portion of a .vob file (used on DVDs), outputting to an SDL window

        gst-launch filesrc location=movie.mpg ! mpegdemux name=demuxer ! mpeg2dec ! sdlvideosink demuxer. ! mad ! osssink
Play both video and audio portions of an MPEG movie

        gst-launch filesrc location=movie.mpg ! mpegdemux name=demuxer ! { queue ! mpeg2dec ! sdlvideosink } { demuxer. ! queue ! mad ! osssink }
Use threaded output to improve synchronization and smoothness. Threads require queues for buffering on thread boundaries

        gst-launch filesrc location=movie.avi ! avidemux name=demuxer ! { queue ! ffdecall ! sdlvideosink } { demuxer. ! queue ! mad ! osssink }
Play an AVI movie

Network streaming

An MPEG-1 system stream can be streamed via RTP from one machine to another.

        gst-launch rtprecv media_type=mpeg1_sys ! mpegdemux name=demuxer ! { queue ! mpeg2dec ! xvideosink } { demuxer. ! queue ! mad ! osssink }
Use this command on the receiver

        gst-launch filesrc location=mpeg1system.mpeg ! mpegparse ! rtpsend ip=IPorHostname
This command would be run on the transmitter

Diagnostic

        gst-launch fakesrc ! fakesink
Generate a null stream and ignore it

        gst-launch sinesrc ! osssink
Generate a pure tone to test the audio output

        gst-launch videotestsrc ! xvideosink
Generate a familiar test pattern to test the video output

Automatic linking

You can use the spider element to automatically select the right elements to get a working pipeline.

        gst-launch filesrc location=musicfile ! spider ! osssink
Play any supported audio format

        gst-launch filesrc location=videofile ! spider name=spider ! osssink spider. ! xvideosink
        gst-launch filesrc location=videofile ! spider name=spider ! { queue ! osssink } { spider. ! queue ! xvideosink }
Play any supported video format with video and audio output. The second pipeline uses threaded output.

Filtered connections

These examples show you how to use filtered caps.

        gst-launch videotestsrc ! video/raw, format:fourcc=YUY2; video/raw, format:fourcc=YV12 ! xvideosink
Show a test image and use the YUY2 or YV12 video format for this.

        gst-launch osssrc ! "audio/raw", format=int, width=[16, 32], depth=(16, 24, 32), signed=TRUE ! osssink
Playback currently recorded audio. Force usage of signed 16 to 32 bit samples.

SEE ALSO
gst-complete(1), gst-register(1), gst-inspect(1)

AUTHOR
The GStreamer team at http://gstreamer.net/